
(* -------------------------------------------------------------------- *)
(*	Test3.ML							*)
(*	Tests of ZF-based ML verifier					*)
(* -------------------------------------------------------------------- *)

(* -------------------------------------------------------------------- *)
(*      Two examples showing the different effect of 			*)
(*	sequential and parallel composition				*)
(* -------------------------------------------------------------------- *)

exp_elab "let val var x1 = scon m in \
\          let val var x1 = scon n; val var x2 = var x1 in var x2 end end";	
by elab_tac;

exp_elab "let val var x1 = scon m in \
\         let val var x1 = scon n and var x2 = var x1 in var x2 end end";
by elab_tac;

(* -------------------------------------------------------------------- *)
(*		example showing that static binding is assumed		*)
(* -------------------------------------------------------------------- *)

exp_elab "let val var x2 = scon m in \
\               let val var x1 = var x2 in let val var x2 \
\      = scon n in var x1 end end end";
by elab_tac;

(* -------------------------------------------------------------------- *)
(* 	swap routine 							*)
(* -------------------------------------------------------------------- *)

exp_elab "let val var x1 = scon m; \
    \         val var x2 = scon n; \
    \         val var x3 = var x1; val var x1 = var x2; val var x2 = var x3\
    \    in var x1 end ";
by elab_tac;

(* -------------------------------------------------------------------- *)
(* 	Arithmetic operations 						*)
(* -------------------------------------------------------------------- *)

exp_elab "scon m ++ scon n";
by elab_tac;



