(* -------------------------------------------------------------*)
(*								*)
(*		elab_atpat.thy:					*)
(*								*)
(* ------------------------------------------------------------ *)

elab_atpat = elab_exbind +

rules

Wild_Pat    "(0 = VE) <-> C ||- _ ~>  (VE, t) [Pat]" (* Rule 33  *)

Scon_Pat    "(0 = VE & int = t) <-> C ||- scon n ~> (VE, t) [Pat]"
						(* -- Rule 34  *)

Var_Pat     "({<<Var, x>, <All, 0, t>>} = VE) <->   \
\            C ||- var x ~>  (VE, t) [Pat]"      (* Rule 35  *)

Con_Pat	  "(EX T U SE TE EE VE s.  C = <T, U, SE, TE, VE, EE> &  \
\           VE ` <Con, c> = s & s [>] t & 0 = VE')  <->  \
\          C ||- con c ~> (VE', t) [Pat]"  (* -- Rule 36  *) 

ExCon_Pat  "(EX T U SE TE EE VE. C = <T, U, SE, TE, VE, EE> &  \
\           VE ` <ExCon, e> = exn &  0 = VE') <->  \
\          C ||- excon c ~> (VE', exn) [Pat]"   (* -- Rule 37  *)
 
Empty_Record_Pat "(0 = VE & <RecType, 0> = t) <-> \
\                      C ||- {{}} ~> (VE, t) [Pat]" (* Rule 38a *)

Record_Pat      "(C ||- patrow ~> (VE, rectype) [PatRow] & \
\                  <RecType, rectype> = t)  <-> \
\                C ||- {{patrow}} ~> (VE, t) [Pat]"  (* -- Rule 38b *)

Bracket_Pat	"C ||- pat ~> (VE, t) [Pat] <-> \
\                      C ||- (- pat -) ~> (VE, t) [Pat]" (* Rule 39 *)


end
