
(* -------------------------------------------------------------------- *)
(*									*)
(*		Test3.ML						*)	
(*									*)
(* -------------------------------------------------------------------- *)

(* -------------------------------------------------------------------- *)
(*      Two examples showing the different effect of 			*)
(*	sequential and parallel composition				*)
(* -------------------------------------------------------------------- *)

exp_eval   "let val var x1 = scon m in \
\          let val var x1 = scon n; val var x2 = var x1 in var x2 end end";	
by eval_tac;

exp_eval "let val var x1 = scon m in \
\           let val var x1 = scon n and var x2 = var x1 in var x2 end end";
by eval_tac;

(* -------------------------------------------------------------------- *)
(*		example showing that static binding is assumed		*)
(* -------------------------------------------------------------------- *)

exp_eval "let val var x2 = scon m in \
\               let val var x1 = var x2 in let val var x2 \
\      = scon n in var x1 end end end";
by eval_tac;

(* -------------------------------------------------------------------- *)
(* 	swap routine 							*)
(* -------------------------------------------------------------------- *)

exp_eval "let val var x1 = scon m; \
\             val var x2 = scon n;  \
\             val var x3 = var x1;  \
\             val var x1 = var x2; \
\             val var x2 = var x3 \
\         in (- var x1, var x2 -) end";
by eval_tac;

(* -------------------------------------------------------------------- *)
(* 	Arithmetic operations 						*)
(* -------------------------------------------------------------------- *)

exp_eval "scon m ++ scon n";
by eval_tac;

exp_eval "scon m -- scon n";
by eval_tac;

exp_eval "scon m ** scon n";
by eval_tac;


