

(* -------------------------------------------------------------------- *)
(*									*)
(*		Test4.ML						*)	
(*									*)
(* -------------------------------------------------------------------- *)

(* -------------------------------------------------------------------- *)
(* 	Functions							*)
(* -------------------------------------------------------------------- *)

exp_eval "let val var f1 = fn var x1 => var x1 in var f1 end";
by eval_tac;

exp_eval "let val var f1 = fn var x1 => var x1 in \
     \ var f1 ` var f1 end";
by eval_tac;

exp_eval "(- fn var x1 => var x1 -)` scon n ";
by eval_tac;


exp_eval "(- fn var x3 => var plus -)`var times "; 
by eval_tac;

exp_eval 
  "let val var f1 = fn var x1 => fn var x2 => \
   \  (-var x1, var x2-) in \
   \  (- var f1` scon n -)` var plus  end";
by eval_tac;

(* -------------------------------------------------------------------- *)
(* 	Pattern Matching						*)
(* -------------------------------------------------------------------- *)


exp_eval "let val var f1 = fn scon 0 => scon 0 | _ => scon succ(0) \
\         in var f1 ` scon 0 end";
by eval_tac;

exp_eval "let val var f1 = fn scon 0 => scon 0 | _ => scon succ(0) \
\         in var f1 ` scon succ(0) end";
by eval_tac;


exp_eval "let val var f1 = \
\ fn (-var x1, scon succ (0)-) => var x1 | _  => scon 0 \
     \  in var f1 ` (-scon r, scon succ (0)-) end";
by eval_tac;

exp_eval "let val var f1 = \
\  fn (-var x1, scon succ (0)-) => var x1 | _  => scon 0 \
     \  in var f1 ` (-scon r, scon 0-) end";
by eval_tac;

(* -------------------------------------------------------------------- *)
(* 	 This is a famous nasty LISP example  				*)
(* 	- p311 in Winston & Horn					*)
(*	Note that x1 appears as both a bound and a free variable!	*)
(* -------------------------------------------------------------------- *)


exp_eval
 "let val var x1 = scon m;	\
  \   val var f1 = fn var f3 => fn var x1 => \
  \          (- var f3` (- var f3 ` var x1 -)-); \
  \   val var f2 = fn var x2 => (- var x2 ** var x1 -) in \
  \      (-var f1 ` var f2 -)` scon n end";
by eval_tac;
