(* -------------------------------------------------------------------- *)
(*			 Kernel.ML	  				*)
(* -------------------------------------------------------------------- *)

val Kernel_cs = ZF_cs addIs [equalityI] addSEs 
		Tags_elim_rules @ Ide_elim_rules;

(*      tactic for solving subgoals of the form                 *)
(*	{<x,a>, ...} : A -> B or a : {...} or <A,B> = <A,B'>    *)
(*      SELECT_GOAL is needed to stop fun_tac going berserk	*)

fun fun_tac cs = fn i =>
SELECT_GOAL  
 (REPEAT1 
  ((resolve_tac [fun_single, fun_extend, fun_empty, consI1, consI2] ORELSE' 
   fast_tac cs) i)) i;

fun kernel_step_tac ths cs =  
 ares_tac (injection_rules @ ZF_ext_rules @ ths @ [pair_eq, refl])
 ORELSE' fun_tac cs;

fun kernel_tac ths = DEPTH_SOLVE_1 o (kernel_step_tac ths Kernel_cs);
