
(* -------------------------------------------------------------*)
(*		Map.ML: 					*)
(*		Derived Rules for Finite Maps			*)
(* ------------------------------------------------------------ *)

open Map;


val mapI = prove_goalw thy [map_def]
 "[| f : C -> B; C : Fin (A) |] ==> f : A -fin-> B"
 (fn prems => 
 [cut_facts_tac prems 1,
  REPEAT(ares_tac (prems@[UN_I]) 1)]);

val mapD = prove_goalw thy [map_def]
 "f : A -fin-> B ==> f : domain (f) -> B"
 (fn prems => 
 [cut_facts_tac prems 1, 
  etac UN_E 1, 
  asm_simp_tac (ZF_ss addsimps [domain_of_fun]) 1]);

val mapE = prove_goalw thy [map_def]
 "[| f : A -fin-> B;  !!C. [| f : C -> B; C : Fin(A) |] ==> R |] ==> R"
 (fn major::prems => 
  [resolve_tac [major RS UN_E] 1,
   REPEAT (ares_tac prems 1)]);





