(* -------------------------------------------------------------*)
(*		Tags.ML: 					*)
(*	Derived Rules for Constructing Distinct Identifiers	*)
(* ------------------------------------------------------------ *)

open Tags;

val tacfun = fn prems => [cut_facts_tac prems 1, fast_tac ZF_cs 1];

val black_inject =
prove_goalw thy [black_def]
 "black(m) = black(n) ==> m = n" tacfun;

val white_inject =
prove_goalw thy [white_def]
  "white(m) = white(n) ==> m = n" tacfun;

val white_neq_black =
prove_goalw thy [white_def, black_def] 
 "white(m) = black(n) ==> P" tacfun;

val white_neq_0 =
prove_goalw thy [white_def] 
 "white(m) = 0 ==> P" tacfun;

val black_neq_0 =
prove_goalw thy [black_def] 
 "black(m) = 0 ==> P" tacfun;

val Tags_elim_rules =
[white_neq_black, sym RS white_neq_black,
            white_neq_0, sym RS white_neq_0,
            black_neq_0, sym RS black_neq_0] @ 
   map make_elim [black_inject, white_inject];
